summaryrefslogtreecommitdiff
path: root/tests/tail-2/F-vs-missing
diff options
context:
space:
mode:
authorPádraig Brady <P@draigBrady.com>2010-10-12 01:39:58 +0100
committerPádraig Brady <P@draigBrady.com>2010-10-12 11:41:17 +0100
commit61b77891c2d9af299063850a0c4d1d721340cfff (patch)
tree53d70fd61a8c64ab6be607a0f9083ff6583f0886 /tests/tail-2/F-vs-missing
parent9f4744534f1de87b9630dfbde91b9ebd9592d056 (diff)
downloadcoreutils-61b77891c2d9af299063850a0c4d1d721340cfff.tar.xz
tail: fix checking of currently unavailable directories
* src/tail.c (tail_forever_inotify): Handle the case where tail --follow=name with inotify, is not able to add a watch on a specified directory. This may happen due to inotify resource limits or if the directory is currently missing or inaccessible. In all these cases, revert to polling which will try to reopen the file later. Note inotify returns ENOSPC when it runs out of resources, and instead we report a particular error message, lest users think one of their file systems is full. (main): Document another caveat with using inotify, where we currently don't recheck directories recreated after the initial watch is setup. * tests/tail-2/F-vs-rename: Fix the endless loop triggered by the above issue. * tests/tail-2/inotify-hash-abuse: Likewise. * tests/tail-2/wait: Don't fail in the resource exhaustion case. * tests/tail-2/F-vs-missing: A new test for this failure mode which was until now just triggered on older buggy linux kernels which returned ENOSPC constantly from inotify_add_watch(). * NEWS: Mention the fix.
Diffstat (limited to 'tests/tail-2/F-vs-missing')
-rwxr-xr-xtests/tail-2/F-vs-missing49
1 files changed, 49 insertions, 0 deletions
diff --git a/tests/tail-2/F-vs-missing b/tests/tail-2/F-vs-missing
new file mode 100755
index 000000000..8c1d01898
--- /dev/null
+++ b/tests/tail-2/F-vs-missing
@@ -0,0 +1,49 @@
+#!/bin/sh
+# demonstrate that tail -F works for currently missing dirs
+# Before coreutils-8.6, tail -F missing/file would not
+# notice any subsequent availability of the missing/file.
+
+# Copyright (C) 2010 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/init.sh"; path_prepend_ ../src
+test "$VERBOSE" = yes && tail --version
+
+debug='---disable-inotify'
+debug=
+tail $debug -F -s.1 missing/file > out 2>&1 & pid=$!
+
+check_tail_output()
+{
+ local delay="$1"
+ grep "$tail_re" out > /dev/null ||
+ { sleep $delay; return 1; }
+}
+
+# Wait up to 6.3s for tail to start with diagnostic:
+# tail: cannot open `missing/file' for reading: No such file or directory
+tail_re='cannot open' retry_delay_ check_tail_output .1 7 || fail=1
+
+mkdir missing || fail=1
+(cd missing && echo x > file)
+
+# Wait up to 6.3s for this to appear in the output:
+# "tail: `...' has appeared; following end of new file"
+tail_re='has appeared' retry_delay_ check_tail_output .1 7 ||
+ { echo "$0: file: unexpected delay?"; cat out; fail=1; }
+
+kill -HUP $pid
+
+Exit $fail